(* Title: tests for ListC
   Author: Walther Neuper 030501
   (c) copyright due to lincense terms.
*)

"-----------------------------------------------------------------------------";
"-----------------------------------------------------------------------------";
"table of contents -----------------------------------------------------------";
"-----------------------------------------------------------------------------";
"--------------------- NTH ---------------------------------------------------";
"--------------------- LENGTH ------------------------------------------------";
"--------------------- tl ----------------------------------------------------";
"-----------------------------------------------------------------------------";
"-----------------------------------------------------------------------------";


"--------------------- NTH ---------------------------------------------------";
"--------------------- NTH ---------------------------------------------------";
"--------------------- NTH ---------------------------------------------------";
val list_rls = assoc_rls "list_rls"

val t = str2term "NTH 1 [a,b,c,d,e]";
atomty t;
val thm = (#prop o rep_thm o num_str) @{thm NTH_NIL};
atomty thm;
val SOME (t', _) = rewrite_ thy dummy_ord list_rls false (num_str @{thm NTH_NIL}) t;
if term2str t' = "a" then () 
else error "NTH 1 [a,b,c,d,e] = a ..changed";

val t = str2term "NTH 3 [a,b,c,d,e]";
val Const ("ListC.NTH", _) $ Free ("3", _) $ (Const ("List.list.Cons", _) $ Free ("a", _) $
  (Const ("List.list.Cons", _) $ Free ("b", _) $ 
    (Const _ $ Free _ $ (Const _ $ Free _ $ (Const _ $ Free _ $ Const _))))) = t;
atomty t;
val thm = (#prop o rep_thm o num_str) @{thm NTH_CONS};
atomty thm;
val SOME (t', _) = rewrite_ thy dummy_ord list_rls false (num_str @{thm NTH_CONS}) t;
if term2str t' = "NTH (3 + -1) [b, c, d, e]" then () 
else error "NTH 3 [a,b,c,d,e] = NTH (3 + - 1) [b, c, d, e] ..changed";

(* now the argument "(3 + - 1)" etc needs to be evaluated in the assumption of NTH_CONS *)
val t = str2term "NTH 3 [a,b,c,d,e]";
atomty t;
trace_rewrite := true;
val SOME (t', _) = rewrite_set_ thy false list_rls t;
trace_rewrite := false;
if term2str t' = "c" then () 
else error "NTH 3 [a,b,c,d,e] = c ..changed";

"--------------------- LENGTH ------------------------------------------------";
"--------------------- LENGTH ------------------------------------------------";
"--------------------- LENGTH ------------------------------------------------";
val list_rls = assoc_rls "list_rls"

val thy = @{theory ListC};
val t = str2term "LENGTH [1, 1, 1]";
val SOME (t, asm) = rewrite_ thy tless_true tval_rls false @{thm LENGTH_CONS} t;
term2str t = "1 + LENGTH [1, 1]";
val SOME (t, asm) = rewrite_ thy tless_true tval_rls false @{thm LENGTH_CONS} t;
term2str t = "1 + (1 + LENGTH [1])";
val SOME (t, asm) = rewrite_ thy tless_true tval_rls false @{thm LENGTH_CONS} t;
term2str t = "1 + (1 + (1 + LENGTH []))";
val NONE          = rewrite_ thy tless_true tval_rls false @{thm LENGTH_CONS} t;
val SOME (t, asm) = rewrite_ thy tless_true tval_rls false @{thm LENGTH_NIL} t;
val NONE          = rewrite_ thy tless_true tval_rls false @{thm LENGTH_NIL} t;
if term2str t = "1 + (1 + (1 + 0))" then () 
else error "LENGTH [1, 1, 1] = 1 + (1 + (1 + 0))  ..changed";

val t = str2term "LENGTH [1, 1, 1]";
val SOME (t, asm) = rewrite_set_ thy false list_rls t;
if term2str t = "3" then ()
else error "LENGTH [1, 1, 1] = 3  ..list_rls changed";

val t = str2term "LENGTH [1, 1, 1]";
val t = eval_listexpr_ thy list_rls t;
case t of Free ("3", _) => () 
| _ => error "LENGTH [1, 1, 1] = 3  ..eval_listexpr_ changed";

