(*  Title:      ~~test/../ProgLang/calculate.thy
    Author:     Walther Neuper
*)

theory calculate
imports Build_Thydata
begin

text {*
  *setup* KEStore_Elems.add_pbts / add_mets is impossible in *.sml files.
  The respective test/../calculate.sml is called in Test_Isac.thy.
*}

ML {*
"-calculate.thy: provides 'setup' -----------------------";
"-calculate.thy: provides 'setup' -----------------------";
"-calculate.thy: provides 'setup' -----------------------";
*}

setup {* KEStore_Elems.add_pbts
  [prep_pbt @{theory "Test"} "pbl_ttest" [] e_pblID (["test"], [], e_rls, NONE, []),
    prep_pbt @{theory "Test"} "pbl_ttest_calc" [] e_pblID
      (["calculate","test"],
        [("#Given" ,["realTestGiven t_t"]),
          ("#Find"  ,["realTestFind s_s"])],
        e_rls, NONE, [["Test","test_calculate"]])] *}

setup {* KEStore_Elems.add_mets
  [prep_met (@{theory "Test"}) "met_testcal" [] e_metID
      (["Test","test_calculate"]:metID,
        [("#Given" ,["realTestGiven t_t"]), ("#Find"  ,["realTestFind s_s"])],
        {rew_ord'="sqrt_right",rls'=tval_rls,srls=e_rls,prls=e_rls,
          calc=[("PLUS"    ,("op +"        ,eval_binop "#add_")),
              ("TIMES"   ,("Groups.times_class.times"        ,eval_binop "#mult_")),
              ("DIVIDE" ,("HOL.divide"  ,eval_cancel "#divide_")),
              ("POWER"  ,("Atools.pow"  ,eval_binop "#power_"))],
          crls=tval_rls, errpats = [], nrls=e_rls (*, asm_rls=[],asm_thm=[]*)},
        "Script STest_simplify (t_t::real) =          \
        \(Repeat                                        \
        \ ((Try (Repeat (Calculate PLUS))) @@   \
        \  (Try (Repeat (Calculate TIMES))) @@  \
        \  (Try (Repeat (Calculate DIVIDE))) @@ \
        \  (Try (Repeat (Calculate POWER))))) t_t")]
*}

end
